VERSION 5.00
Begin VB.Form frmNumberToWord 
   Caption         =   "Number To Word"
   ClientHeight    =   2220
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   4695
   LinkTopic       =   "Form1"
   ScaleHeight     =   2220
   ScaleWidth      =   4695
   StartUpPosition =   3  'Windows Default
   Begin VB.CommandButton cmdSOCurrency 
      Caption         =   "To Word"
      Height          =   330
      Left            =   3735
      TabIndex        =   7
      Top             =   1215
      Width           =   870
   End
   Begin VB.TextBox txtCurrency 
      Height          =   285
      Left            =   1440
      TabIndex        =   5
      Text            =   "0"
      Top             =   1215
      Width           =   2265
   End
   Begin VB.CommandButton cmdSpellOut 
      Caption         =   "Spell Out"
      Height          =   330
      Left            =   3780
      TabIndex        =   3
      Top             =   225
      Width           =   825
   End
   Begin VB.TextBox txtNumber 
      Height          =   330
      Left            =   1440
      TabIndex        =   1
      Text            =   "0"
      Top             =   225
      Width           =   2265
   End
   Begin VB.Label lblSpellOutCurrency 
      Caption         =   "lblSpellOutCurrency"
      Height          =   510
      Left            =   135
      TabIndex        =   6
      Top             =   1620
      Width           =   4470
   End
   Begin VB.Label lblCurrency 
      Caption         =   "Currency"
      Height          =   285
      Left            =   135
      TabIndex        =   4
      Top             =   1215
      Width           =   1275
   End
   Begin VB.Label lblSpellOut 
      Caption         =   "lblSpellOut"
      Height          =   465
      Left            =   135
      TabIndex        =   2
      Top             =   675
      Width           =   4425
   End
   Begin VB.Label lblNumber 
      Caption         =   "Number"
      Height          =   240
      Left            =   135
      TabIndex        =   0
      Top             =   270
      Width           =   1230
   End
End
Attribute VB_Name = "frmNumberToWord"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Public Function CurrencyToWord(DollarAmount As Variant) As String

    Dim strDollars      As String
    Dim strWholeAmount  As String
    Dim strCents        As String
    Dim lngDecimalPos   As Long
    
    Dim strOutput       As String
    
    strWholeAmount = DollarAmount
    strDollars = "0"
    strCents = "0"
    
    lngDecimalPos = InStr(strWholeAmount, ".")
    
    If lngDecimalPos Then
        If lngDecimalPos > 1 Then
            strDollars = Trim$(Left$(strWholeAmount, lngDecimalPos - 1))
        Else
            strDollars = "0"
        End If
        
        If Len(strWholeAmount) - lngDecimalPos = 0 Then
            strCents = "0"
        Else
            strCents = Trim$(Mid$(strWholeAmount, lngDecimalPos + 1))
        End If
        If Len(strCents) = 1 And strCents <> "0" Then strCents = strCents & "0"
    Else
        strDollars = strWholeAmount
        strCents = "0"
    End If
    
    ' We need to round off the extra
    If Len(strCents) > 2 Then strCents = Left$(strCents, 2)
    
    Debug.Print "Dollars : " & strDollars, "Cents : " & strCents
    
    strOutput = NumberToWord(strDollars) & "dollars and "
    strOutput = strOutput & NumberToWord(strCents) & "cents"
    
    CurrencyToWord = strOutput

End Function

Public Function NumberToWord(NumberString As Variant) As String
    'The best data type to feed in is
    'Decimal, but it is up to you

    Dim strTemp As String
    Dim strNew As String

    NumberString = CDec(NumberString)

    If NumberString = 0 Then
        NumberToWord = "no "
        Exit Function
    End If

    If NumberString > 10 ^ 24 Then
        NumberToWord = ""
        Exit Function
    End If

    If NumberString >= 10 ^ 12 Then
        strNew = NumberToWord(Int(NumberString / 10 ^ 12))
        NumberString = ((NumberString / 10 ^ 12) - Int(NumberString / 10 ^ 12)) * 10 ^ 12
        If NumberString = 0 Then
            strTemp = strTemp & strNew & "billion "
        Else
            strTemp = strTemp & strNew & "billion, "
        End If
    End If

    If NumberString >= 10 ^ 6 Then
        strNew = NumberToWord(Int(NumberString / 10 ^ 6))
        NumberString = ((NumberString / 10 ^ 6) - Int(NumberString / 10 ^ 6)) * 10 ^ 6
        If NumberString = 0 Then
            strTemp = strTemp & strNew & "million "
        Else
            strTemp = strTemp & strNew & "million, "
        End If
    End If

    If NumberString >= 10 ^ 3 Then
        strNew = NumberToWord(Int(NumberString / 10 ^ 3))
        NumberString = ((NumberString / 10 ^ 3) - Int(NumberString / 10 ^ 3)) * 10 ^ 3
        If NumberString = 0 Then
            strTemp = strTemp & strNew & "thousand "
        Else
            strTemp = strTemp & strNew & "thousand, "
        End If
    End If

    If NumberString >= 10 ^ 2 Then
        strNew = NumberToWord(Int(NumberString / 10 ^ 2))
        NumberString = ((NumberString / 10 ^ 2) - Int(NumberString / 10 ^ 2)) * 10 ^ 2
        If NumberString = 0 Then
            strTemp = strTemp & strNew & "hundred "
        Else
            strTemp = strTemp & strNew & "hundred and "
        End If
    End If

    If NumberString >= 20 Then
        Select Case Int(NumberString / 10)
            Case 2
                strTemp = strTemp & "twenty "
            Case 3
                strTemp = strTemp & "thirty "
            Case 4
                strTemp = strTemp & "forty "
            Case 5
                strTemp = strTemp & "fifty "
            Case 6
                strTemp = strTemp & "sixty "
            Case 7
                strTemp = strTemp & "seventy "
            Case 8
                strTemp = strTemp & "eighty "
            Case 9
                strTemp = strTemp & "ninety "
        End Select
        NumberString = ((NumberString / 10) - Int(NumberString / 10)) * 10
    End If

    If NumberString > 0 Then
        Select Case NumberString
            Case 1
                strTemp = strTemp & "one "
            Case 2
                strTemp = strTemp & "two "
            Case 3
                strTemp = strTemp & "three "
            Case 4
                strTemp = strTemp & "four "
            Case 5
                strTemp = strTemp & "five "
            Case 6
                strTemp = strTemp & "six "
            Case 7
                strTemp = strTemp & "seven "
            Case 8
                strTemp = strTemp & "eight "
            Case 9
                strTemp = strTemp & "nine "
            Case 10
                strTemp = strTemp & "ten "
            Case 11
                strTemp = strTemp & "eleven "
            Case 12
                strTemp = strTemp & "twelve "
            Case 13
                strTemp = strTemp & "thirteen "
            Case 14
                strTemp = strTemp & "fourteen "
            Case 15
                strTemp = strTemp & "fifteen "
            Case 16
                strTemp = strTemp & "sixteen "
            Case 17
                strTemp = strTemp & "seventeen "
            Case 18
                strTemp = strTemp & "eighteen "
            Case 19
                strTemp = strTemp & "nineteen "
        End Select
        NumberString = ((NumberString / 10) - Int(NumberString / 10)) * 10
    End If
    
    NumberToWord = strTemp
End Function

Private Sub cmdSOCurrency_Click()
    lblSpellOutCurrency.Caption = CurrencyToWord(txtCurrency.Text)
End Sub

Private Sub cmdSpellOut_Click()
    lblSpellOut.Caption = NumberToWord(txtNumber.Text)
End Sub

